#include "blowfish.h"

#include <stdio.h>
#include <string.h>

void
store (unsigned char byte, void *user_data)
{
  *((*(unsigned char **)user_data)++) = byte;
}

void
do_check (int n)
{
  unsigned char dm6[8], dm5[8], dm4[8], dm3[8], dm2[8], dm1[8], d0[8], d1[8];
  unsigned char key[56], cleartext[8], ciphertext[8];
  unsigned char *ptr;
  struct blf_ecb_ctx context;
  int i, j;

  printf ("KEYSIZE=%d\n", n*8);
  printf ("\n");
  memset (dm6, 0, 8);
  memset (dm5, 0, 8);
  memset (dm4, 0, 8);
  memset (dm3, 0, 8);
  memset (dm2, 0, 8);
  memset (dm1, 0, 8);
  memset (d0, 0, 8);
  memset (d1, 0, 8);
  for ( i=1 ; i<=49 ; i++ )
    {
      memcpy (key, d0, 8);
      if ( n > 8 )
	memcpy (key+8, dm1, n<16?n-8:8);
      if ( n > 16 )
	memcpy (key+16, dm2, n<24?n-16:8);
      if ( n > 24 )
	memcpy (key+24, dm3, n<32?n-24:8);
      if ( n > 32 )
	memcpy (key+32, dm4, n<40?n-32:8);
      if ( n > 40 )
	memcpy (key+40, dm5, n<48?n-40:8);
      if ( n > 48 )
	memcpy (key+48, dm6, n-48);
      memcpy (cleartext, d1, 8);
      ptr = ciphertext;
      Blowfish_ecb_start (&context, 1, key, n,
			  store, (void *)&ptr);
      for ( j=0 ; j<8 ; j++ )
	Blowfish_ecb_feed (&context, cleartext[j]);
      Blowfish_ecb_stop (&context);
      printf ("I=%d\n", i);
      printf ("KEY=");
      for ( j=0 ; j<n ; j++ )
	printf ("%02X", key[j]);
      printf ("\n");
      printf ("PT=");
      for ( j=0 ; j<8 ; j++ )
	printf ("%02X", cleartext[j]);
      printf ("\n");
      printf ("CT=");
      for ( j=0 ; j<8 ; j++ )
	printf ("%02X", ciphertext[j]);
      printf ("\n");
      printf ("\n");
      memcpy (dm6, dm5, 8);
      memcpy (dm5, dm4, 8);
      memcpy (dm4, dm3, 8);
      memcpy (dm3, dm2, 8);
      memcpy (dm2, dm1, 8);
      memcpy (dm1, d0, 8);
      memcpy (d0, d1, 8);
      memcpy (d1, ciphertext, sizeof(d1));
    }
}

int
main (void)
{
  do_check (8);
  do_check (16);
  do_check (24);
  do_check (32);
  do_check (56);
  return 0;
}
