#include "sha1.h"

#include <stdio.h>

int
main (int argc, const char *argv[])
{
  int i, j;
  struct sha1_ctx context;
  unsigned char digest[20];
  FILE *f;
  const char *bogus_argv[] = { "zoinx", "-" };
  const char hexdigits[17] = "0123456789abcdef";

  if ( argc == 1 )
    {
      argc = 2;
      argv = bogus_argv;
    }
  for ( i=1 ; i<argc ; i++ )
    {
      if ( argv[i][0] == '-' && argv[i][1] == 0 )
	f = stdin;
      else
	{
	  f = fopen (argv[i], "rb");
	  if ( ! f )
	    {
	      fprintf (stderr, "Error opening %s\n", argv[i]);
	      continue;
	    }
	}
      SHA1_start (&context);
      while ( 1 )
	{
	  int ch;

	  ch = getc (f);
	  if ( ch == EOF )
	    break;
	  SHA1_feed (&context, ch);
	}
      SHA1_stop (&context, digest);
      for ( j=0 ; j<20 ; j++ )
	{
	  putchar (hexdigits[digest[j]>>4]);
	  putchar (hexdigits[digest[j]&0xf]);
	}
      printf ("  %s\n", argv[i]);
    }
  return 0;
}
