#include "twofish.h"

#include <stdio.h>
#include <string.h>

void
store (unsigned char byte, void *user_data)
{
  *((*(unsigned char **)user_data)++) = byte;
}

void
do_check (int n)
{
  unsigned char dm1[16], d0[16], d1[16];
  unsigned char key[32], cleartext[16], ciphertext[16];
  unsigned char *ptr;
  struct twf_ecb_ctx context;
  int i, j;

  printf ("KEYSIZE=%d\n", n*8);
  printf ("\n");
  memset (dm1, 0, 16);
  memset (d0, 0, 16);
  memset (d1, 0, 16);
  for ( i=1 ; i<=49 ; i++ )
    {
      memcpy (key, d0, 16);
      if ( n > 16)
	memcpy (key+16, dm1, n-16);
      memcpy (cleartext, d1, 16);
      ptr = ciphertext;
      Twofish_ecb_start (&context, 1, key, n,
			 store, (void *)&ptr);
      for ( j=0 ; j<16 ; j++ )
	Twofish_ecb_feed (&context, cleartext[j]);
      Twofish_ecb_stop (&context);
      printf ("I=%d\n", i);
      printf ("KEY=");
      for ( j=0 ; j<n ; j++ )
	printf ("%02X", key[j]);
      printf ("\n");
      printf ("PT=");
      for ( j=0 ; j<16 ; j++ )
	printf ("%02X", cleartext[j]);
      printf ("\n");
      printf ("CT=");
      for ( j=0 ; j<16 ; j++ )
	printf ("%02X", ciphertext[j]);
      printf ("\n");
      printf ("\n");
      memcpy (dm1, d0, 16);
      memcpy (d0, d1, 16);
      memcpy (d1, ciphertext, sizeof(d1));
    }
}

int
main (void)
{
  do_check (16);
  do_check (24);
  do_check (32);
  return 0;
}
